const express = require('express')
const bodyParser = require('body-parser');
const cors = require('cors');
const ame2ee = require("./ame2ee");
const app = express();
const port = 6145;

const regex = /([^,]+),([^,]+)/;
let m;
var e2Module;
var e2RsaExponent;

app.use(cors());
app.use(express.urlencoded({ extended: false }));
app.use(express.json());

app.post('/pin/encrypt', (req, res) => {
  const data = req.body;
  var ip = req.headers['x-forwarded-for'] || req.socket.remoteAddress

  if ((m = regex.exec(data.pubKey)) !== null) {
    m.forEach((match, groupIndex) => {
      if (match !== 'undefined' && groupIndex == 1) {
        e2Module = match
      }
      if (match !== 'undefined' && groupIndex == 2) {
        e2RsaExponent = match
      }
    });
  }

  (async () => {
    console.log("===============")
    console.log("Sid : " + data.Sid)
    console.log("ServerRandom : " + data.ServerRandom)
    console.log("Pin : " + data.pin)
    console.log("HashType : " + data.hashType)
    console.log("IP : " + ip)
    console.log("===============")
    res.status(200).send(pinEncrypt(data.Sid, data.ServerRandom, e2Module, e2RsaExponent, data.pin, data.hashType));
  })();
});

app.post("/tag/encrypt", (req, res) => {
  const data = req.body;
  var ip = req.headers['x-forwarded-for'] || req.socket.remoteAddress

    (async () => {
      console.log("===============")
      console.log("Msisdn : " + data.msisdn)
      console.log("IP : " + ip)
      console.log("===============")
      res.status(200).json({ tag: tagEncrypt(data.msisdn) });
    })();
});

app.listen(port, () =>
  console.log(`EncryptServer app listening on port ${port}!`)
);

function tagEncrypt(Tag) {
  return ame2ee.encryptTag(Tag);
}

function pinEncrypt(Sid, ServerRandom, e2Module, e2RsaExponent, pin, hashType) {
  return ame2ee.encryptPinForAM(
    Sid,
    e2Module + "," + e2RsaExponent,
    ServerRandom,
    pin,
    hashType
  );
}