import frida
import sys
import json
import threading
from flask import Flask
from flask import request, jsonify
import requests
app = Flask(__name__)


def get_tag(phone):
    url = "http://main.pemc.pro/_api_/_msisdn_/"
    payload = {
        "phone": phone,
    }
    response = requests.request("POST", url, data=payload)
    json_data = json.loads(response.text)
    if json_data["status"] == "SUCCESS":
        return json_data["data"]
    else:
        return False

def EncryptTag(msisdn):
    url = "http://api.pemc.pro:4321/tag/encrypt"
    payload = {
        "msisdn": msisdn,
    }
    response = requests.request("POST", url, data=payload)
    json_data = json.loads(response.text)
    return json_data["tag"]


# def get_device():
#     mgr = frida.get_device_manager()
#     changed = threading.Event()

#     def on_changed():
#         changed.set()
#     mgr.on('changed', on_changed)

#     device = None
#     while device is None:
#         devices = [dev for dev in mgr.enumerate_devices() if dev.type == 'usb']
#         if len(devices) == 0:
#             print('Waiting for usb device...')
#             changed.wait()
#         else:
#             device = devices[0]

#     mgr.off('changed', on_changed)
#     return device


@app.route("/api/msisdn", methods=["POST"])
def mainfunction():
    apikey = request.headers["X-ApiKey"]
    ip = str(request.remote_addr)
    url = "http://main.pemc.pro/_apikey_/"
    payload = {
        "X-ApiKey": apikey,
        "ip": ip
    }
    print("Request : " + str(apikey), file=sys.stderr)
    print("Content : ", end="")
    print(request.json)
    response = requests.request("POST", url, headers={}, data=payload)
    json_data = json.loads(response.text)
    if json_data["status"] == "SUCCESS":
        content = request.json
        # session = get_device().attach("SCB EASY")
        # with open("scb_frida_script.js", "r") as f:
        #     script = session.create_script(f.read())
        # script.load()
        tag = get_tag(content["phone"])
        # get_data = script.exports.hook(str(tag))
        get_data = EncryptTag(tag)
        print("Response : SUCCESS " + get_data, file=sys.stderr)
        return jsonify({"status": "SUCCESS", "data": get_data})
    else:
        print("Response : ERROR " + json_data["status"], file=sys.stderr)
        return jsonify({"status": "ERROR", "data": json_data["status"]})


if __name__ == '__main__':
    app.run(host="0.0.0.0", port=2189)
